identification division.
program-id.	xmlgen.
author.		Randy Zack.
remarks.
	This program demonstrates simple XML generation with the XML GENERATE
	verb.
	Compile with -Dw32

data division.
working-storage section.
01 Struct.
   02 StaT PIC X(4).
   02 In-Area PIC X(100).
   02 OK-AREA REDEFINES IN-AREA.
      03 FLAGS PIC X.
      03 PIC X(3).
      03 COUNTER USAGE COMP-5 PIC S9(9).
      03 ASFNPTR REDEFINES COUNTER USAGE POINTER.
      03 UNREFERENCED PIC X(92).
   02 NG-AREA1 REDEFINES IN-AREA.
      03 FLAGS PIC X.
      03 PIC X(3).
      03 PTR USAGE POINTER.
      03 ASNUM REDEFINES PTR USAGE COMP-5 PIC S9(9).
      03 PIC X(92).
   02 NG-AREA2 REDEFINES IN-AREA.
      03 FN-CODE PIC X.
      03 UNREFERENCED PIC X(3).
      03 QTYONHAND USAGE BINARY PIC 9(5).
      03 UNREFERENCED PIC X(12).
   02 more-data.
      03 numeric-data-1   pic s9(7)v99 comp-5.
      03 numeric-data-2   pic s9(7)v99 comp-5.
      03 numeric-data-3   pic s9(7)v99 comp-5.
      03 numeric-data-4   pic s9(7)v99 comp-5.
      03 numeric-data-5   pic s9(7)v99 comp-5.
01 xml-data-len unsigned-int.
01 XML-DATA.
   02  occurs 1 to 32767 times depending on xml-data-len
       PIC X.
01 xml-counter unsigned-int.

procedure division.
main-pgh.
    display window erase.
    move all "x" to xml-data.
    move 23 to xml-counter.
    move low-values to stat.
    move "another & test "" with < special > chars ' &""<>' " to in-area.
    move 1234567.89 to numeric-data-1.
    move 0 to numeric-data-2.
    move 18.7 to numeric-data-3.
    move -1234567.90 to numeric-data-4.
    move -18.65 to numeric-data-5.
    xml generate xml-data from struct count in xml-counter
      on exception
        display "Error generating XML"
      not on exception
        display "XML data is ", xml-data(1:xml-counter)
    end-xml.
    accept omitted.
    stop run.
