       Identification Division.
       Program-Id.  Example-7.
      *
      * Title: EXAMPLE7.CBL: Export / Well-Formed test / Validate.
      *
      * Copyright (c) 2008-2010, Micro Focus (IP) Ltd.
      *
      * Version Identification:
      *   $Revision: 59838 $
      *   $Date: 2010-12-21 19:33:53 +0000 (Tue, 21 Dec 2010) $
      *
       Data Division.
       Working-Storage Section.

       Copy "s-struct.cpy".

       01  Done Pic X.
       01  WS-TimeStamp.
           02 WS-Date       PIC 9999/99/99.
           02 Filler        PIC XX Value Spaces.
           02 WS-Time       PIC 99/99/99/99.

       Copy "lixmlall.cpy".

       Procedure Division.
       A.
           Display "Example-7 - Illustrate TEST-WELLFORMED FILE"
                   " & VALIDATE FILE".

           XML INITIALIZE.
           If Not XML-OK Go to Z End-If.

           Accept WS-Date From Date YYYYMMDD.
           Accept WS-Time From Time.
           Inspect WS-Time Converting "/" To ":".
           Move "." To WS-Time(9: 1).
           Move WS-TimeStamp To Time-Stamp.

           XML EXPORT FILE
               Address-Struct    *> reference to export source data item (input)
               "address7"        *> output document file name (input)
               Struct-Name.      *> model data name string (input)
           If Not XML-OK Go to Z End-If.

           Display Space.
           Display "address7.xml exported by XML EXPORT FILE".
           Perform Display-Address-Struct.

           XML TEST WELLFORMED-FILE
               "address7".       *> document to test file name (input)
           If Not XML-OK Go to Z End-If.

           Display Space.
           Display "address7.xml checked by XML TEST WELLFORMED-FILE".

           XML VALIDATE FILE
               "address7"        *> document to validate file name (input)
               "example7".       *> XML Schema document for validation (input)
           If Not XML-OK Go to Z End-If.

           Display Space.
           Display "address7.xml validated by XML VALIDATE FILE".
           Initialize Address-Struct.

           XML IMPORT FILE
               Address-Struct   *> reference to import target data item (input)
               "address7"       *> input document file name (input)
               Struct-Name.     *> model data name string (input)
           If Not XML-OK Go to Z End-If.

           Display Space.
           Display "address7.xml imported by XML IMPORT FILE".
           Perform Display-Address-Struct.

           Display Space.
           Display "You may inspect 'address7.xml'".
           Display Space.
           Go to Z.

       Display-Address-Struct.
           Display Space.
           Display "Name:        " Name.
           Display "Address-1:   " Address-1.
           Display "Address-2:   " Address-2.
           Display "Address-3:   " Address-3.
           Display "Country:     " Country.
           Display "Time-Stamp:  " Time-Stamp.

       Z.
           Copy "lixmltrm.cpy".

           Display "Press a key to terminate:".                         TESTS
           Accept Done.                                                 TESTS
           Stop Run.

           Copy "lixmldsp.cpy".

       End Program  Example-7.
